//
//      AWSTabControl.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "pself3.hpp"
#include "AWSTabControl.hpp"
#include "SGRSoftkeyWindow.hpp"
#include "SGRSoftkeyToolbox.hpp"

//++++++++++++++++++++++++++LinkLabel class implementation+++++++++++++++++++++++++++++//
// Constructor
LinkLabel::LinkLabel(SFRResponderPtr director, SFXRectangleConstRef rect, SFXWideStringConstRef title, BehaviorType behavior)
: SFRButtonBase(director, rect, SFMRESPONDERFILTER(LINKLABEL, behavior), four_char_code('L', 'l', 'b', 'l'))
{
    _title = title;
    return;
}

// Destructor
LinkLabel::~LinkLabel(Void)
{
	_title.Clear();
    return;
}

// Set title
Void LinkLabel::SetTitle(SFXWideStringConstRef param)
{
    if (param != _title) {
        _title = param;
        InvalidateButton();
    }
    return;
}

// Get title
SFXWideStringConstRef LinkLabel::GetTitle(Void) const
{
    return _title;
}

Void LinkLabel::HandleRelease(Void)
{
    Invoke(SFXEvent(SREVT_CONTROL, 0, reinterpret_cast<UInt32>(this)));
    return;
}

Void LinkLabel::HandleContent(SFXGraphicsPtr graphics)
{
    SInt16 width = SFXGraphics::MeasureText(AEE_FONT_NORMAL, _title);
    SGRSoftkeyWindowPtr softkey;

    graphics->FillRectangle(GetVirtualWorld().SetWidth(width), SFXRGBColor(0xEE, 0xEE, 0xEE, 0x00));
    if (GetInheritFocus()) 
	{
        graphics->FillRectangle(GetVirtualWorld().SetWidth(width), SFXRGBColor(0x33, 0x33, 0xFF, 0x00));
		// draw text to the screen
        graphics->DrawText(_title, GetVirtualWorld(), SFXRGBColor(0xFF, 0xFF, 0x00, 0x00), SFRLabelControl::ALIGN_LEFT);
        // register softkey and change the softkey label
		if ((softkey = SGRSoftkeyWindow::GetInstance()) != null)
            static_throw(softkey->Register(this->GetDirector()->GetDirector()->GetDirector(), SGRSoftkeyWindow::SOFTKEY_3, "Detail"));
    } 
	else 
		// draw text to the screen
        graphics->DrawText(_title, GetVirtualWorld(), SFXRGBColor(0x00, 0x00, 0xFF, 0x00), SFRLabelControl::ALIGN_LEFT);

    return;
}
//++++++++++++++++++++++End of LinkLabel class implementation++++++++++++++++++++++++++//

//++++++++++++++++++++++++++ScrollTabPane class implementation+++++++++++++++++++++++++++++//

// Constructor
ScrollTabPane::ScrollTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title)
    : SFRTabPane(tab, title)
{
    if (static_try()) 
	{
        static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
        if (static_try()) 
            static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_AFTER, HANDLER_FUNCTION(OnRender)));
    }

    return;
}

Void ScrollTabPane::SetHeight(SInt16 height)
{
    SFXRectangle rect(GetContentBound());
    SetVirtualBound(SFXRectangle(rect.GetLeft(), rect.GetTop(), rect.GetWidth(), height));
}

// Key Handler
HANDLER_IMPLEMENT_BOOLEVENT(ScrollTabPane, OnKey, event)
{
    SFRResponderPtr responder(null);
    SFXRectangle rect;
    Bool ret(false);

    switch (event.GetP16()) {
        case AVK_UP:
            if (GetFocus())
                responder = GetFocus()->GetPrevious(TYPE_WILDCARD, ATTRIBUTE_WILDCARD, STATUS_VISIBLE | STATUS_ENABLE, false);
            
            if (responder) 
			{
                Travel(responder->GetBaseBound());
                FocusPrevious();
                ret = true;
            } 
			else 
			{
                if (-GetVirtualBound().GetTop() > 0) 
				{
                    Scroll(SFXSize(0, -SFXGraphics::GetFontHeight(AEE_FONT_NORMAL)));
                    ret = true;
                }
            }
            break;
        case AVK_DOWN:
            if (GetFocus())
                responder = GetFocus()->GetNext(TYPE_WILDCARD, ATTRIBUTE_WILDCARD, STATUS_VISIBLE | STATUS_ENABLE, false);
            
            if (responder) 
			{
                rect = responder->GetBaseBound();
                Travel(rect.AddY(GetContentWorld().GetHeight() / 2));
                FocusNext();
            } 
			else 
                Scroll(SFXSize(0, SFXGraphics::GetFontHeight(AEE_FONT_NORMAL)));
            
            ret = true;
            break;
    }
    return ret;
}

// drawing handler
HANDLER_IMPLEMENT_VOIDRENDER(ScrollTabPane, OnRender, graphics)
{
    unused(graphics);
    SGRSoftkeyWindowPtr softkey;
    SFRResponderPtr responder;

    responder = GetDirector()->GetDirector()->GetFocus();

    if (GetInheritFocus() == false && (responder != null && responder->GetAttribute() == ATTRIBUTE_SFRTABCONTROL))
	{
        Scroll(SFXSize(0, -GetVirtualBound().GetHeight()));

        if ((softkey = SGRSoftkeyWindow::GetInstance()) != null)
            static_throw(softkey->Register(this->GetDirector()->GetDirector(), SGRSoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
        
    }
    return;
}
//++++++++++++++++++++++End of ScrollTabPane class implementation++++++++++++++++++++++++++//

//++++++++++++++++++++++++++AWSTabPane class implementation+++++++++++++++++++++++++++++//

// Constructor
AWSTabPane::AWSTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title)
    : ScrollTabPane(tab, title), _maxWidth(0)
{
    return;
}

// Destructor
AWSTabPane::~AWSTabPane(Void)
{
    Clear();
    return;
}

// Make labels
SFCError AWSTabPane::MakeLabels(Void)
{
    SFXRectangle temp(GetContentWorld().Deflate(CONTROL_MARGIN, CONTROL_MARGIN));
    SFXRectangle temp2(temp);
    LinkLabelPtr linklabel;
	
    SInt16 i, height;
    SFCError error(SFERR_NO_ERROR);

	if(_maxWidth>GetContentWorld().GetWidth()/2)
	return MakeLabelsLineFeed();

    temp.SetWidth(_maxWidth);
    temp2.Set(temp.GetRight(), temp2.GetTop(), temp2.GetRight() - temp.GetRight(), 0);

	for (i = 0; i < _value.GetSize(); ++i) 
	{
        height = SFXGraphics::MeasureString(AEE_FONT_NORMAL, _value.GetValue(i), temp2.GetWidth());
        temp.SetHeight(height); 
		temp2.SetHeight(height);
		
		if ((::new SFRLabelControl(this, temp, _value.GetKey(i), SFRLabelControl::ALIGN_RIGHT)) != null) 
		{
		    if ((_value.GetKey(i).FirstIndexOf("ISBN") == 0)|| (_value.GetKey(i).FirstIndexOf("ASIN") == 0)) 
			{
                if ((linklabel = ::new LinkLabel(this, temp2, _value.GetValue(i))) != null) 
				{
                    if (static_try()) {
                        static_throw(linklabel->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnLink)));
                    }
                    temp.AddY(temp.GetHeight() + CONTROL_MARGIN);
                    temp2.AddY(temp2.GetHeight() + CONTROL_MARGIN);
                } 
				else 
				{
                    error = SFERR_NO_MEMORY;
                    break;
                }
            } 
			else 
			{
                if ((::new SFRLabelControl(this, temp2, _value.GetValue(i), SFRLabelControl::ALIGN_LEFT)) != null)
				{
                    temp.AddY(temp.GetHeight() + CONTROL_MARGIN);
                    temp2.AddY(temp2.GetHeight() + CONTROL_MARGIN);
                } 
				else 
				{
                    error = SFERR_NO_MEMORY;
                    break;
                }
            }
            if (_value.GetKey(i).FirstIndexOf("Title") == 0) 
			{
                temp.AddY(CONTROL_MARGIN * 3);
                temp2.AddY(CONTROL_MARGIN * 3);
            }
        } 
		else 
		{
            error = SFERR_NO_MEMORY;
            break;
        }
    }

    SetHeight(temp.GetTop());
    return error;
}

SFCError AWSTabPane::MakeLabelsLineFeed(Void)
{
    SFXRectangle temp(GetContentWorld().Deflate(CONTROL_MARGIN, CONTROL_MARGIN));
    LinkLabelPtr linklabel;
	
    SInt16 i, height;
    SFCError error(SFERR_NO_ERROR);

	for (i = 0; i < _value.GetSize(); ++i) 
	{
		height = SFXGraphics::MeasureString(AEE_FONT_NORMAL, _value.GetKey(i), temp.GetWidth());
		temp.SetHeight(height); 

		if ((::new SFRLabelControl(this, temp, _value.GetKey(i), SFRLabelControl::ALIGN_LEFT)) == null) 
		{
			error = SFERR_NO_MEMORY;
            return error;
		}

		temp.AddY(temp.GetHeight() + CONTROL_MARGIN);

		height = SFXGraphics::MeasureString(AEE_FONT_NORMAL, _value.GetValue(i), temp.GetWidth());
		temp.SetHeight(height); 

		if ((_value.GetKey(i).FirstIndexOf("ISBN") == 0)|| (_value.GetKey(i).FirstIndexOf("ASIN") == 0)) 
		{
			if ((linklabel = ::new LinkLabel(this, temp, MARGIN_LINEFEED + _value.GetValue(i))) == null) 
			{
				error = SFERR_NO_MEMORY;
				return error;
            }
			
			if (static_try()) 
		         static_throw(linklabel->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnLink)));
			
			temp.AddY(temp.GetHeight() + CONTROL_MARGIN);
            
        } 
		else 
		{
            if ((::new SFRLabelControl(this, temp, MARGIN_LINEFEED + _value.GetValue(i), SFRLabelControl::ALIGN_LEFT)) == null)
			{
				error = SFERR_NO_MEMORY;
                return (error);
            
			}
			temp.AddY(temp.GetHeight() + CONTROL_MARGIN);
            
        }

        if (_value.GetKey(i).FirstIndexOf("Title") == 0) 
		{
			temp.AddY(CONTROL_MARGIN * 3);
        }
    }

    SetHeight(temp.GetTop());
    return error;
}

// link clicked handler 
HANDLER_IMPLEMENT_VOIDCONTROL(AWSTabPane, OnLink, result, control)
{
    unused(result);
    unused(control);

	return; // do nothing
}

SFCError AWSTabPane::Append(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value)
{
    UInt16 length;
    SFCError error(_value.Append(name + ": ", value));
    if (error == SFERR_NO_ERROR) 
	{
        if ((length = SFXGraphics::MeasureText(AEE_FONT_NORMAL, name + ": ")) > _maxWidth) 
            _maxWidth = length;
    }

    return error;
}

SFCError AWSTabPane::Append(SFXAnsiStringConstRef name, SInt32 value)
{
    return Append(name, SFXAnsiString::Format("%d", value));
}

Void AWSTabPane::Clear(Void)
{
	_string.Clear();
	_value.Clear();
    return;
}
//++++++++++++++++++++++End of AWSTabPane class implementation++++++++++++++++++++++++++//

//++++++++++++++++++++++++++AWSImageTabPane class implementation+++++++++++++++++++++++++++++//

// Constructor
AWSImageTabPane::AWSImageTabPane(SFRTabControlPtr tab, SFXWideStringConstRef title, SFXAnsiStringConstRef url, SFXAnsiStringConstRef asin)
    : ScrollTabPane(tab, title), _url(url), _asin(asin)
{
    if (static_try()) {
        static_throw(
            RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT,
                        HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
    }

    SFXAnsiStringConst filename(DIR_NAME + _asin + ".jpg");
    _image = SFBShell::GetInstance()->LoadImage(filename);

    if (_image == null) { // if there is no image then create this button
        SFXRectangle rect(0, 0, SFXGraphics::MeasureText(AEE_FONT_NORMAL, STRING_GETIMAGE) + 30, SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + 5);
        rect.SetX((GetContentWorld().GetWidth() - rect.GetWidth()) / 2);
        rect.SnapBottom(GetContentWorld().GetBottom() - 10);

        SFRButtonControlPtr button = ::new SFRButtonControl(this, rect, STRING_GETIMAGE);
        if (button != null) {
            if (static_try()) {
                static_throw(
                    button->RegisterHandler(
                        SREVT_CONTROL, HANDLER_BEFORE,
                        HANDLER_FUNCTION(OnButtonControl)));
            }
        }
    }
    return;
}

// Destructor
AWSImageTabPane::~AWSImageTabPane(Void)
{
    _url.Clear();
    _asin.Clear();

    return;
}

HANDLER_IMPLEMENT_VOIDCONTROL(AWSImageTabPane, OnButtonControl, result, control)
{
    unused(result);

    static_cast<SFRButtonControlPtr>(control)->SetStatusEnable(false);
    static_cast<SFRButtonControlPtr>(control)->SetTitle("Connecting...");
    _http.Open();
    _http.SetMethod("GET");
    _http.Connect(_url, CALLBACK_FUNCTION(ConnectCallback));
}

// Drawing handleridraw in the windowj
HANDLER_IMPLEMENT_VOIDRENDER(AWSImageTabPane, OnRenderContent, graphics)
{
	SFRTabPane::ContentHandler(graphics);

    if (_image != null) 
	{
        AEEImageInfo info = {0};
        _image->GetInfo(&info);
        graphics->DrawImage(_image, SFXGrid((GetContentWorld().GetWidth() - info.cx) / 2, 10));
    }
    return;
}

// Callback function to notify connect establishment
CALLBACK_IMPLEMENT_SFXHTTPCONNECTION(AWSImageTabPane, ConnectCallback, error)
{
    if (error == SFERR_NO_ERROR) {
        // get the reading stream
        error = _http.GetStreamReader(1024, &_reader);
        if (error == SFERR_NO_ERROR) {
            // receive data
            error = _reader.Fetch(CALLBACK_FUNCTION(FetchCallback));
        }
    }
    if (error != SFERR_NO_ERROR) {
        ProceedNetworkError();
    }
    return;
}

// Callback function to notify data receiving
CALLBACK_IMPLEMENT_SFXBINARYSTREAMREADER(AWSImageTabPane, FetchCallback, error)
{
    SFXBuffer buffer;

    if (error == SFERR_NO_ERROR) 
	{

	buffer.SetSize(_reader.GetReadableSize());
    _reader.Read(&buffer);
    _imageBuffer += buffer;

    if (_reader.Ends() && _reader.GetReadableSize() == 0) 
	{ // data reception end
            _http.Close(); // terminate SFXHTTPConnection

            SFXFile file;
            SFXBinaryStreamWriter writer;
            SFXPathConst filename(DIR_NAME + _asin + ".jpg");

            file.OpenReadWrite(filename);
            file.GetStreamWriter(_imageBuffer.GetSize(), &writer);
            writer.Write(_imageBuffer);
            writer.Flush();
            file.Close();
            _imageBuffer.Free();

            _image = SFBShell::GetInstance()->LoadImage(filename.AsFile());

            // destroy the button after all data received
            SFRResponderPtr button(GetFront(TYPE_SFRCONTROL, ATTRIBUTE_SFRBUTTONCONTROL, STATUS_VISIBLE));
            if (button != null) 
                button->Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
            
			if (_image != null) 
			{
				InvalidateContent();
				SFRApplication::GetInstance()->Invoke(SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));
			}
        }
        else // receive the remaing data
            _reader.Fetch(CALLBACK_FUNCTION(FetchCallback));
        
    }
    else	ProceedNetworkError();
    
    return;
}

Void AWSImageTabPane::ProceedNetworkError(Void)
{
    _http.Close();

    // enable the button if receiving failed 
    SFRButtonControlPtr button(static_cast<SFRButtonControlPtr>(GetFront(TYPE_SFRCONTROL, ATTRIBUTE_SFRBUTTONCONTROL, STATUS_VISIBLE)));
    if (button != null) 
	{
        button->SetStatusEnable(true);
        button->SetTitle(STRING_GETIMAGE);
    }
}

//++++++++++++++++++++++End of AWSImageTabPane class implementation++++++++++++++++++++++++++//

// constructor
AWSDisplayWindow::AWSDisplayWindow(SFXAnsiStringConstRef searchindex, SFXAnsiStringConstRef asin, SFXAnsiStringConstRef	title, Bool addedToFavorites) static_throws
    : SFRPlainWindow(SFRApplication::GetInstance(), SGRSoftkeyToolbox::GetWindowPosition(), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_AWSDISPLAYWINDOW),
	_searchindex(searchindex), _asin(asin), _title(title), _addedToFavorites(addedToFavorites)
{
    SGRSoftkeyWindowPtr softkey;
	
	//favorite file
	_favoriteFileName = DIR_NAME + _searchindex + ".dat";

	// register key handler
    if (static_try()) static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
    
	// register softkey handler
    SGRSoftkeyWindow::Initialize(this);
    if (!static_try()) return;
	
	static_throw(RegisterHandler(static_cast<SFCEventEnum>(SGRSoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
    if (!static_try())return;
    
	if ((softkey = SGRSoftkeyWindow::GetInstance()) == null) return;

	//register softkey labels
	static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
    if (!static_try()) return;
	
	static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
    if (!static_try()) return;
    
	static_throw(softkey->Register(this, SGRSoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
	if (!static_try()) return;

	SetReference(softkey->Bind(this));
    
    //SFRApplication::GetInstance()->Invoke(SFXEvent(SREVT_RESPONDER_RENDER, SRP16_RENDER_INVOKE, false));

    return;
}

// Destructor
AWSDisplayWindow::~AWSDisplayWindow(Void)
{
    SGRSoftkeyWindow::Terminate(this);
	SFXPathConst filenameXML(DIR_NAME + _asin + ".xml");
	SFXPathConst filenameJPG(DIR_NAME + _asin + ".jpg");

	if (! _addedToFavorites)
	{
		SFXFile::Remove(filenameXML);
		SFXFile::Remove(filenameJPG);
	}

	_searchindex.Clear();
	_asin.Clear();
	_title.Clear();
	_favoriteFileName.Clear();

    return;
}

// Key handler
HANDLER_IMPLEMENT_BOOLEVENT(AWSDisplayWindow, OnKey, event)
{
    switch (event.GetP16()) {
        case AVK_UP:
            FocusUp();
            return true;
        case AVK_LEFT:
            FocusLeft();
            return true;
        case AVK_DOWN:
            FocusDown();
            return true;
        case AVK_RIGHT:
            FocusRight();
            return true;
        case AVK_SELECT:
        case AVK_CLR:
            // Distroy this window
            return Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    }
    return false;
}

// Softkey handler
HANDLER_IMPLEMENT_VOIDEVENT(AWSDisplayWindow, OnSoftkey, event)
{
    SFRTextMenuPtr menu;

    SFCError error(SFERR_NO_ERROR);

    switch (event.GetP16()) {
        case SGRSoftkeyWindow::SOFTKEY_1: // terminate apllication
			SFRApplication::Terminate();
            break;
        case SGRSoftkeyWindow::SOFTKEY_2: // create menu
            if ((menu = ::new SFRTextMenu(SGRSoftkeyToolbox::GetMenuPosition(OPERATION_LIMIT), "Favorites", null, 0)) == null)
				break;
			
			if ((error = menu->static_catch()) != SFERR_NO_ERROR) 
			{
				::delete menu;
				break;
			}
			
			if ((error = menu->AppendItem("Add", AVK_1, 0xFBF6)) != SFERR_NO_ERROR) 
				break;
					
            if ((error = menu->AppendItem("Back", AVK_2, 0xFCF6)) != SFERR_NO_ERROR) 
				break;
            
			SGRSoftkeyToolbox::OpenStandardMenu(menu, HANDLER_FUNCTION(FromSoftkey));
            
            break;
    }
    return;
}

//menu item selected handler
HANDLER_IMPLEMENT_VOIDMENU(AWSDisplayWindow, FromSoftkey, result, menu)
{
    SFRMessageDialogPtr dialog;

    switch (result) {
        case OPERATION_ADD:
            // close menu
			SGRSoftkeyToolbox::CloseStandardMenu(menu);

			// if already exist in favorite list 
			if (_addedToFavorites)
	            dialog = ::new SFRMessageDialog(GetContentWorld().Deflate(20, 0).SetHeight(100).AddY(80), "Already exists on your Favorites", "OK");
            else
			{// add this product to favorite list
				AddToFavorites();
				_addedToFavorites = true;
			}
			break;
        case OPERATION_BACK: // close menu
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            break;
        case SRP16_ESCAPE:
        case SRP16_CANCEL:
            SGRSoftkeyToolbox::CloseStandardMenu(menu);
            break;
    }
    return;
}

// add current displayed product to favorite list
SFCError AWSDisplayWindow::AddToFavorites(Void)
{
	SFCError error;
    UInt16 size;
	SFXConfig	_config;

	error= _config.Load(SFXPath(_favoriteFileName));
	if (error != SFERR_NO_ERROR) return error;

	size = _config.ReadUInt16(0, 0);

    _config.WriteUInt16(0, size+1);

    _config.WriteSFXAnsiString(size * 2 + 1, _asin);
    _config.WriteSFXAnsiString(size * 2 + 2, _title);
    
    error = _config.Save();

	return error;
}

