//
//      SGRNetworkDialogSet.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#ifndef __SGRNETWORKDIALOGSET_HPP
#define __SGRNETWORKDIALOGSET_HPP

#include <SophiaFramework.hpp>
#include "SGRSoftkeyToolbox.hpp"
#include "SGRErrorDialogSet.hpp"

SFMTYPEDEFCLASS(SGRNetworkDialogSet)
class SGRNetworkDialogSet 
{
    SFMSEALCOPY(SGRNetworkDialogSet)
public:
    enum NotifyEnum {
        NOTIFY_CONNECT_START,
        NOTIFY_CONNECT_CANCEL,
        NOTIFY_CONNECT_END,
        NOTIFY_ERROR
    };
    typedef Void (*NetworkDialogSetSPP)(NotifyEnum, SFCError, VoidPtr);
private:
    SFXHTTPConnection		_http;
    SFXBinaryStreamReader	_reader;
    SFXBuffer				_receivedBuffer;
    SFXAnsiString			_url;
    NetworkDialogSetSPP		_spp;
    VoidPtr					_reference;
    SFRDialogPtr			_dialog;
	SFXAnsiString			_ok;
	SFXAnsiString			_cancel;
	SFXAnsiString			_text;
	SFXAnsiString			_title;
	SGRErrorDialogSet		_errorDialog;

	Bool _connecting; // network connection status

public:
    SGRNetworkDialogSet(Void);
    virtual ~SGRNetworkDialogSet(Void);
    SFCError Open(SFXAnsiStringConstRef url, Bool isConfirm, NetworkDialogSetSPP procedure, VoidPtr data, SFXAnsiStringConstRef title="", SFXAnsiStringConstRef text="", SFXAnsiStringConstRef ok = "", SFXAnsiStringConstRef cancel = "");

	SFXBufferConstRef GetData(Void) { return _receivedBuffer; }
	
    Void ClearData(Void) { _receivedBuffer.Free(); }
	Bool IsConnecting(Void) { return _connecting;}

private:
    Void ProceedNetworkError(Void);
    SFCError Connect(Void);

    HANDLER_DECLARE_VOIDDIALOG(OnDialog)
    CALLBACK_DECLARE_SFXHTTPCONNECTION(ConnectCallback)
    CALLBACK_DECLARE_SFXANSISTRINGSTREAMREADER(FetchCallback)
	HANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
	HANDLER_DECLARE_VOIDRESUME(OnResume)
};


#endif //__SGRNETWORKDIALOGSET_HPP //
