//
//      TagTracer.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.1
//

#include "TagTracer.hpp"

/*
** TagTracer class implementation
*/
// Constructor
TagTracer::TagTracer(Void) 
{
	_haveStartCommand = false;
	_haveEndCommand = false;
    return;
}

TagTracer::TagTracer(pt2AWSProductMember cm) 
{
	_haveStartCommand = false;
	_haveEndCommand = true;
	_endCommand = cm;
    return;
}

TagTracer::TagTracer(pt2AWSProductMember startCm, pt2AWSProductMember endCm) 
{
	_haveStartCommand = true;
	_startCommand = startCm;

	_haveEndCommand = true;
	_endCommand = endCm;

    return;
}

// Destructor
TagTracer::~TagTracer(Void)
{
    return;
}


Void TagTracer::Trace(SFXAnsiStringConstRef tagname, TagTracerPtr tracer)
{
	_traceMap.Set(tagname, tracer);
}

Void TagTracer::OnStart(SFXAnsiStringConstRef tagname, TracerTypeStackPtr stack, CallerProcedureSPP caller_procedure, VoidPtr caller)
{
	// get a tag tracer for the tagname from the trace map
	TagTracerPtr tracer = _traceMap.Get(tagname);

	// if tracer for the tagname is not found in the trace map, skip this tag (and all its followers) by placing a skip object in top of the stack
	if (tracer == null)
	{
		TagTracerSkipPtr _skip = new TagTracerSkip();
		stack->Push(_skip);
	}
	// if tracer with key = tagname found, do the associated command and push it in to the stack
	else
	{
		if (tracer->HaveStartCommand())
		{
			// notify AWSSAXParser
			_spp = caller_procedure;
			_spp(tagname, tracer->GetStartCommand(), caller);
		}	
		// push the found tracer into the stack
		stack->Push(tracer);
	}
}

Void TagTracer::OnEnd (TracerTypeStackPtr stack, SFXAnsiString data, CallerProcedureSPP caller_procedure, VoidPtr caller)
{
	// pop the tracer from the stack and do the associated command 
	TagTracerPtr tracer = stack->Pop();

	if (tracer->HaveEndCommand())
	{
		// notify AWSSAXParser
		_spp = caller_procedure;
		_spp(data, tracer->GetEndCommand(), caller);
	}
}

/*
** TagTracerSkip class implementation
*/

// Constructor
TagTracerSkip::TagTracerSkip(Void) 
{
	return;
}

// Destructor
TagTracerSkip::~TagTracerSkip(Void)
{
    return;
}

Void TagTracerSkip::OnStart(SFXAnsiStringConstRef tagname, TracerTypeStackPtr stack)
{
	stack->Push(this);
}

Void TagTracerSkip::OnEnd (TracerTypeStackPtr stack)
{
	stack->Pop();
}